## libfreesrp 0.3.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.4)
project(libfreesrp)

set(VERSION_MAJOR "0")
set(VERSION_MINOR "3")
set(VERSION_PATCH "0")
set(VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake/modules")

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11")

# FreeSRP Library
find_package(libusb-1.0 REQUIRED)

include_directories(${LIBUSB_1_INCLUDE_DIR})

file(GLOB_RECURSE LIBFREESRP_SRC_FILES
    ${PROJECT_SOURCE_DIR}/src/*.hpp
    ${PROJECT_SOURCE_DIR}/src/*.cpp
)

file(GLOB_RECURSE LIBFREESRP_INCLUDE_FILES
    ${PROJECT_SOURCE_DIR}/include/*.hpp
)

file(GLOB_RECURSE READERWRITERQUEUE_INCLUDE_FILES
    ${PROJECT_SOURCE_DIR}/src/readerwriterqueue/*.h
)

add_library(
    freesrp
    SHARED
    ${LIBFREESRP_SRC_FILES}
    ${LIBFREESRP_INCLUDE_FILES}
)

if(CMAKE_BUILD_TYPE STREQUAL "Debug")
    message("-- WARNING: Configured in DEBUG mode. This will *very heavily* impact performance!")
endif()

set_target_properties(freesrp PROPERTIES VERSION ${VERSION} SOVERSION ${VERSION_MAJOR})
target_link_libraries(freesrp ${LIBUSB_1_LIBRARIES})

# Examples
include_directories(${PROJECT_SOURCE_DIR}/include)

# freesrp-io, using callbacks instead of busy waiting
set(EXAMPLE_TEST_SOURCE_FILES ${PROJECT_SOURCE_DIR}/examples/io/main.cpp)
add_executable(freesrp-io ${EXAMPLE_TEST_SOURCE_FILES})
target_link_libraries(freesrp-io freesrp pthread)

# freesrp-ctl
file(GLOB_RECURSE FREESRP_CTL_FILES
    ${PROJECT_SOURCE_DIR}/examples/ctl/*.hpp
    ${PROJECT_SOURCE_DIR}/examples/ctl/*.cpp
)
add_executable(freesrp-ctl ${FREESRP_CTL_FILES})
target_link_libraries(freesrp-ctl freesrp)

# Install library
install(TARGETS freesrp LIBRARY DESTINATION lib)
install(FILES ${LIBFREESRP_INCLUDE_FILES} DESTINATION include)

# Install freesrp-ctl and freesrp-io utilities
install(TARGETS freesrp-ctl freesrp-io RUNTIME DESTINATION bin)

=== debian/changelog ===
libfreesrp (0.3.0-5) unstable; urgency=medium

  * handle missing sem_t in hurd better in apple-mach patch

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 16 Dec 2023 07:46:19 -0500

libfreesrp (0.3.0-4) unstable; urgency=medium

  * skip sysmbols file - C++ is arch-specific

 -- A. Maitland Bottoms <bottoms@debian.org>  Sat, 16 Dec 2023 01:04:15 -0500

libfreesrp (0.3.0-3) unstable; urgency=medium

  * update standards-version
  * add upstream metadata
  * update watch file
  * simplify usb build-depends
  * apple-mach patch for hurd build (Closes: #882572)

 -- A. Maitland Bottoms <bottoms@debian.org>  Fri, 15 Dec 2023 23:13:20 -0500

libfreesrp (0.3.0-2) unstable; urgency=medium

  * build with libusb-1.0-0-dev stub on hurd-i386 (Closes: #882514)

 -- A. Maitland Bottoms <bottoms@debian.org>  Thu, 23 Nov 2017 21:08:47 -0500

libfreesrp (0.3.0-1) unstable; urgency=medium

  * New package (Closes: #874534)

 -- A. Maitland Bottoms <bottoms@debian.org>  Wed, 06 Sep 2017 01:44:38 -0400

=== debian/control ===
Source: libfreesrp
Section: libs
Priority: optional
Maintainer: A. Maitland Bottoms <bottoms@debian.org>
Build-Depends: cmake,
               debhelper-compat (= 13),
	       libboost-dev,
               libusb-1.0-0-dev,
               pkg-config
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: http://freesrp.org/

Package: libfreesrp-dev
Section: libdevel
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: libfreesrp0 (= ${binary:Version}), ${misc:Depends}, ${shlibs:Depends}
Description: Software defined radio support for FreeSRP hardware (development files)
 The FreeSRP has a tuning range from 70 MHz to 6 GHz, uses a 12-bit
 ADC with a sampling rate of up to 61.44 MSPS, and has a maximum
 analog filter bandwidth of 56 MHz. It is a full-duplex radio (can
 transmit & receive at the same time). The main chip in the unit is
 the fairly expensive (~$150 USD) AD9364 integrated RF transceiver
 chip and it also comes with a Xilinx Artix 7 FPGA. Furthermore the
 hardware and code is entirely open source.
 .
 This package is the software that provides control of the USB hardware
 and an API to pass data to software defined radio applications on the host.
 .
 This package contains development files along with a set of command
 line utilities.

Package: libfreesrp0
Architecture: any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Multi-Arch: same
Description: Software defined radio support for FreeSRP hardware (library)
 The FreeSRP has a tuning range from 70 MHz to 6 GHz, uses a 12-bit
 ADC with a sampling rate of up to 61.44 MSPS, and has a maximum
 analog filter bandwidth of 56 MHz. It is a full-duplex radio (can
 transmit & receive at the same time). The main chip in the unit is
 the fairly expensive (~$150 USD) AD9364 integrated RF transceiver
 chip and it also comes with a Xilinx Artix 7 FPGA. Furthermore the
 hardware and code is entirely open source.
 .
 This package is the software that provides control of the USB hardware
 and an API to pass data to software defined radio applications on the host.
 .
 This package contains the shared library.

=== debian/rules ===
#!/usr/bin/make -f
DEB_BUILD_MAINT_OPTIONS += hardening=+all
export DEB_BUILD_MAINT_OPTIONS

%:
	dh $@

=== debian/watch ===
version=4
 opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
 https://github.com/myriadrf/libfreesrp/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate
